<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;

class RelDescConcedidos {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    
    public function findDesConcedidos($params){
        if ($params['TIPORELATORIO'] == 'S'){
            return $this->entityManager->getConnection()->fetchAll(self::GET_DESCONTOS_CONCEDIDOS_SINTETICO, $params);
        }
        else{
            return $this->entityManager->getConnection()->fetchAll(self::GET_DESCONTOS_CONCEDIDOS, $params);
        }
    }
    
    
    public function buildParamsFaturamento($conditions){
        
        if(!array_key_exists('CDFILIAL', $conditions)) {
            $conditions['CDFILIAL'] = '';
            $conditions['TCDFILIAL'] = 'T';
        }else{
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            $conditions['TCDFILIAL'] = '';
        }
        if(!array_key_exists('CDLOJA', $conditions)) {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        } else {
            $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $conditions['TCDLOJA'] = '';
        }
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        
        return $conditions;
    }
    
    const GET_DESCONTOS_CONCEDIDOS = "
        SELECT FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL || ' - ' || FILOCAVE.NMFILIAL ||' - Loja: '|| FILOCAVE.CDLOJA || ' - ' || FILOCAVE.NMLOJA AS LABELFILIAL,
               FILOCAVE.CDVENDEDOR || ' - ' || FILOCAVE.NMRAZSOCVEN AS NMRAZSOCVEN,
               FILOCAVE.CDLOJA || ' - ' || FILOCAVE.NMLOJA AS LABELLOJA, 
               TO_CHAR(FILOCAVE.DTENTRVENDA, 'DD/MM/YYYY') AS DATA, 
               FILOCAVE.CDFILIAL,
               FILOCAVE.NMFILIAL,
               FILOCAVE.NRMESA,
               FILOCAVE.CDLOJA AS CODLOJA,
               FILOCAVE.NMLOJA,
               TO_CHAR(IT.DTHRPEDIDO, 'HH24:MI') AS HORAVENDA,
               IT.CDSUPERVDESC AS CDSUPERVISOR, 
               IT.CDSUPERVDESC || ' - ' || OP2.NMOPERADOR AS NMOPERADOR,
               IT.CDPRODUTO,  
               IT.DSOBSDESCIT, 
               IT.QTPRODVEND * (IT.VRUNITVEND + IT.VRUNITVENDCL) AS VRTOTAL, 
               IT.VRDESITVEND,  
               TRUNC((IT.VRDESITVEND) / (IT.QTPRODVEND * (IT.VRUNITVEND + IT.VRUNITVENDCL))*100, 2) AS PROCENTAGEM,
               OP2.NMOPERADOR AS NMSUPERVISOR,  
               P.CDPRODUTO|| ' - '||P.NMPRODUTO AS NMPRODUTO, 
               P.CDARVPROD
          FROM ITEMVENDA IT
          JOIN PRODUTO P
            ON IT.CDPRODUTO = P.CDPRODUTO
           AND IT.NRORG = P.NRORG
          JOIN ( SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL,
                        FILOCA.NRORG, VE.CDVENDEDOR, VE.NMRAZSOCVEN, V.DTENTRVENDA, V.IDSTATUSNFCE, V.NRMESA
                   FROM VENDA V
                   JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                            FROM CAIXA C 
                            JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG 
                                     FROM LOJA L 
                                     JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                              FROM FILIAL F 
                                             WHERE ( ( INSTR( :CDFILIAL, F.CDFILIAL ) <> 0 ) OR ( :TCDFILIAL = 'T' ) ) 
                                          ) FI 
                                       ON L.CDFILIAL = FI.CDFILIAL
                                      AND L.NRORG = FI.NRORG
                                      AND ( ( INSTR( :CDLOJA, L.CDFILIAL||L.CDLOJA ) <> 0 ) OR ( :TCDLOJA = 'T' ) )
                                 ) FILO 
                              ON C.CDFILIAL = FILO.CDFILIAL
                             AND C.CDLOJA = FILO.CDLOJA
                             AND C.NRORG = FILO.NRORG
                         ) FILOCA 
                      ON V.CDCAIXA = FILOCA.CDCAIXA
                     AND V.CDLOJA = FILOCA.CDLOJA
                     AND V.CDFILIAL = FILOCA.CDFILIAL
                     AND V.NRORG = FILOCA.NRORG
                    LEFT JOIN VENDEDOR VE
                      ON V.CDVENDEDOR = VE.CDVENDEDOR
                     AND V.NRORG = VE.NRORG
                   WHERE V.IDSITUVENDA = 'O'
                     AND V.DTENTRVENDA BETWEEN :DATAINI  AND :DATAFIN
               ) FILOCAVE 
            ON FILOCAVE.CDFILIAL = IT.CDFILIAL
           AND FILOCAVE.CDLOJA = IT.CDLOJA
           AND FILOCAVE.CDCAIXA = IT.CDCAIXA
           AND FILOCAVE.NRSEQVENDA = IT.NRSEQVENDA
           AND FILOCAVE.NRORG = IT.NRORG
          LEFT JOIN OPERADOR OP2
            ON IT.CDSUPERVDESC = OP2.CDOPERADOR
           AND IT.NRORG = OP2.NRORG 
         WHERE IT.VRDESITVEND > 0 
           AND FILOCAVE.DTENTRVENDA BETWEEN :DATAINI  AND :DATAFIN
           AND (INSTR(:CDFILIAL, FILOCAVE.CDFILIAL) <> 0 OR (:TCDFILIAL = 'T' ))
           AND (( INSTR(:CDLOJA , FILOCAVE.CDFILIAL||FILOCAVE.CDLOJA) <> 0 ) OR (:TCDLOJA = 'T'))
           AND NVL(FILOCAVE.IDSTATUSNFCE,'T') <> 'R'
           AND FILOCAVE.IDSITUVENDA = 'O'
           ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DTENTRVENDA, FILOCAVE.CDVENDEDOR
     ";

    const GET_DESCONTOS_CONCEDIDOS_SINTETICO = "
            SELECT L.CDLOJA, 'Todos' AS LABELFILIAL, TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DATA, 
               TO_CHAR(I.DTHRPEDIDO, 'HH24:MI') AS HORAVENDA, 'Todos' AS CDFILIAL, 'Todos' AS NMFILIAL, 
               VE.CDVENDEDOR || ' - ' || VE.NMRAZSOCVEN AS NMRAZSOCVEN,
               I.CDSUPERVDESC AS CDSUPERVISOR, OP2.NMOPERADOR AS NMSUPERVISOR,  V.CDOPERADOR || ' - ' || OP1.NMOPERADOR AS NMOPERADOR,
               V.NRMESA, I.CDPRODUTO,  P.CDPRODUTO|| ' - '||P.NMPRODUTO AS NMPRODUTO, 
               P.CDARVPROD, I.DSOBSDESCIT, I.QTPRODVEND * (I.VRUNITVEND + I.VRUNITVENDCL) AS VRTOTAL, I.VRDESITVEND,  
               TRUNC((I.VRDESITVEND) / (I.QTPRODVEND * (I.VRUNITVEND + I.VRUNITVENDCL))*100, 2) AS PROCENTAGEM,
               L.CDLOJA || ' - ' || L.NMLOJA AS LABELLOJA, L.CDLOJA AS CODLOJA, L.NMLOJA
          FROM VENDA V
          JOIN LOJA L
            ON V.CDLOJA = L.CDLOJA
           AND V.CDFILIAL = L.CDFILIAL
           AND V.NRORG  = L.NRORG
          JOIN ITEMVENDA I
            ON V.NRSEQVENDA = I.NRSEQVENDA
           AND V.CDFILIAL = I.CDFILIAL
           AND V.CDCAIXA = I.CDCAIXA
           AND V.NRORG = I.NRORG
          JOIN PRODUTO P
            ON I.CDPRODUTO = P.CDPRODUTO
           AND I.NRORG = P.NRORG
          JOIN FILIAL F
            ON I.CDFILIAL = F.CDFILIAL
           AND I.NRORG = F.NRORG
          LEFT JOIN VENDEDOR VE
            ON V.CDVENDEDOR = VE.CDVENDEDOR
           AND V.NRORG = VE.NRORG
          JOIN OPERADOR OP1
            ON V.CDOPERADOR = OP1.CDOPERADOR
           AND V.NRORG = OP1.NRORG 
          LEFT JOIN OPERADOR OP2
            ON I.CDSUPERVDESC = OP2.CDOPERADOR
           AND V.NRORG = OP2.NRORG 
         WHERE I.VRDESITVEND > 0 
           AND V.DTENTRVENDA BETWEEN :DATAINI  AND :DATAFIN
           AND V.NRORG = :NRORG
           AND (INSTR(:CDFILIAL, V.CDFILIAL) <> 0 OR (:TCDFILIAL = 'T' ))
           AND (( INSTR(:CDLOJA , V.CDFILIAL||V.CDLOJA) <> 0 ) OR (:TCDLOJA = 'T'))
           AND V.IDSITUVENDA = 'O'
           ORDER BY F.CDFILIAL,V.DTENTRVENDA,VE.CDVENDEDOR
    ";
}