<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelSituPedVend {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function findEfetivos($CDFILIAL, $CDCONSUMIDOR, $TCDCONSUMIDOR, $CDCAIXA, $TCDCAIXA, $DATAINI, $DATAFIN, $NRORG) {
        $params = array(
         	":CDFILIAL" => $CDFILIAL,
         	":CDCONSUMIDOR" => $CDCONSUMIDOR,
         	":TCDCONSUMIDOR" => $TCDCONSUMIDOR,
         	":CDCAIXA" => $CDCAIXA,
         	":TCDCAIXA" => $TCDCAIXA,
         	":DATAINI" => $DATAINI,
         	":DATAFIN" => $DATAFIN,
         	":NRORG" => $NRORG
 		);
 		
 		return $this->entityManager->getConnection()->fetchAll(self::GET_SITU_PEDIDO_VENDA_EFET, $params);
    }
    
    public function findNaoEfetivos($CDFILIAL, $CDCONSUMIDOR, $TCDCONSUMIDOR, $CDCAIXA, $TCDCAIXA, $DATAINI, $DATAFIN, $NRORG) {
        $params = array(
         	":CDFILIAL" => $CDFILIAL,
         	":CDCONSUMIDOR" => $CDCONSUMIDOR,
         	":TCDCONSUMIDOR" => $TCDCONSUMIDOR,
         	":DATAINI" => $DATAINI,
         	":DATAFIN" => $DATAFIN,
         	":NRORG" => $NRORG
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_SITU_PEDIDO_VENDA_NAOEFET, $params);
    }
    
    public function buildParamsFaturamento($conditions){    
        $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        if(!array_key_exists('CDCAIXA', $conditions)) {
            $conditions['CDCAIXA'] = '';
            $conditions['TCDCAIXA'] = 'T';
        } else {
            $conditions['CDCAIXA'] = implode('_', $conditions['CDCAIXA']);
            $conditions['TCDCAIXA'] = '';
        }
        if(!array_key_exists('CDCONSUMIDOR', $conditions)) {
            $conditions['CDCONSUMIDOR'] = '';
            $conditions['TCDCONSUMIDOR'] = 'T';
        } else {
            $conditions['CDCONSUMIDOR'] = implode('_', $conditions['CDCONSUMIDOR']);
            $conditions['TCDCONSUMIDOR'] = 'E';
        }
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        return $conditions;
    }

    const GET_SITU_PEDIDO_VENDA_EFET = "
        SELECT SUM((I.QTPRODVEND *(I.VRUNITVEND + I.VRUNITVENDCL) - (I.VRDESITVEND) + (I.VRACRITVEND))) AS VRTOTVEND, FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, 
               FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS CODFILIAL, FILOCAVE.CDFILIAL AS LABCDFILIAL, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.DTVENDA, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, 
               FILOCAVE.CUPOM, FILOCAVE.CDCONSUMIDOR, FILOCAVE.NMCONSUMIDOR, I.QTPRODVEND, I.VRUNITVEND, P.CDARVPROD, P.NMPRODUTO, 'Cupom: '||FILOCAVE.CUPOM||' - '||'  Data: '||FILOCAVE.DTVENDA||' - '||'  Consumidor: '||FILOCAVE.NMCONSUMIDOR AS LABELVENDA
          FROM ITEMVENDA I
          JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTVENDA,
                      FILOCA.NRORG, V.DTENTRVENDA, NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE) AS CUPOM, V.CDCONSUMIDOR, C.NMCONSUMIDOR
                 FROM VENDA V
                 JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                         FROM CAIXA C
                         JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                 FROM LOJA L
                                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                         FROM FILIAL F
                                        WHERE (INSTR(:CDFILIAL, F.CDFILIAL) > 0)
                                          AND F.NRORG =:NRORG ) FI 
                                   ON L.CDFILIAL = FI.CDFILIAL
                                  AND L.NRORG = FI.NRORG ) FILO 
                           ON C.CDFILIAL = FILO.CDFILIAL 
                          AND C.CDLOJA = FILO.CDLOJA
                          AND C.NRORG = FILO.NRORG
                        WHERE ((INSTR(:CDCAIXA, FILO.CDFILIAL ||C.CDCAIXA) > 0) OR (:TCDCAIXA = 'T'))) FILOCA 
                   ON V.CDCAIXA = FILOCA.CDCAIXA
                  AND V.CDLOJA = FILOCA.CDLOJA
                  AND V.CDFILIAL = FILOCA.CDFILIAL
                  AND V.NRORG = FILOCA.NRORG
                 JOIN CONSUMIDOR C
                   ON V.CDCONSUMIDOR = C.CDCONSUMIDOR
                  AND V.NRORG = C.NRORG
                WHERE V.IDSITUVENDA = 'O'
                  AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                  AND ((INSTR(:CDCONSUMIDOR, V.CDCONSUMIDOR) > 0) OR (:TCDCONSUMIDOR = 'T'))) FILOCAVE
            ON I.CDFILIAL = FILOCAVE.CDFILIAL
           AND I.CDCAIXA = FILOCAVE.CDCAIXA
           AND I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
           AND I.NRORG = FILOCAVE.NRORG
          JOIN PRODUTO P
            ON I.CDPRODUTO = P.CDPRODUTO
           AND I.NRORG = P.NRORG
         GROUP BY FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.DTVENDA, FILOCAVE.NRORG, 
               FILOCAVE.DTENTRVENDA, FILOCAVE.CUPOM, FILOCAVE.CDCONSUMIDOR, FILOCAVE.NMCONSUMIDOR, I.VRUNITVEND, I.QTPRODVEND, P.CDARVPROD, P.NMPRODUTO
    ";

    const GET_SITU_PEDIDO_VENDA_NAOEFET = "
     SELECT FILOREST.NRVENDAREST, FILOREST.NRCOMANDA, FILOREST.CDLOJA, FILOREST.NMLOJA, FILOREST.CDFILIAL, FILOREST.NMFILIAL, FILOREST.NRORG,
            P.NMPRODUTO, P.CDARVPROD, I.VRPRECCOMVEN AS VRUNITVEND,  I.QTPRODCOMVEN AS QTPRODVEND,
            'QRCode: '||FILOREST.NRCOMANDA||' - '||'  Data: '||FILOREST.DTHRABERMESA||' - '||'  Consumidor: '||FILOREST.NMCONSUMIDOR AS LABELVENDA,
            FILOREST.CDFILIAL||' - '||FILOREST.NMFILIAL AS CODFILIAL,
            SUM( I.QTPRODCOMVEN * (I.VRPRECCOMVEN) ) AS VRTOTVEND
       FROM ITCOMANDAVEN I
       JOIN (SELECT C.NRVENDAREST, C.NRCOMANDA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, V.DTHRABERMESA, O.NMCONSUMIDOR, V.CDCONSUMIDOR
               FROM VENDAREST V
               JOIN COMANDAVEN C 
                 ON V.CDFILIAL = C.CDFILIAL 
                AND V.NRVENDAREST = C.NRVENDAREST
                AND V.NRORG = C.NRORG
               JOIN QRCODE Q
                 ON C.CDFILIAL = Q.CDFILIAL
                AND V.CDFILIAL = Q.CDFILIAL
                AND V.CDCONSUMIDOR = Q.CDCONSUMIDOR
                AND C.NRCOMANDA = Q.NRCOMANDA
                AND V.NRVENDAREST = Q.NRVENDAREST
                AND C.NRVENDAREST = Q.NRVENDAREST
                AND Q.NRORG = C.NRORG                 
               JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                               FROM LOJA L
                               JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                       FROM FILIAL F
                                      WHERE (INSTR(:CDFILIAL, F.CDFILIAL) > 0)
                                        AND F.NRORG =:NRORG ) FI 
                                 ON L.CDFILIAL = FI.CDFILIAL
                                AND L.NRORG = FI.NRORG ) FILO 
                 ON FILO.CDFILIAL = V.CDFILIAL
                AND FILO.NRORG = V.NRORG
                AND FILO.CDLOJA = V.CDLOJA
               JOIN CONSUMIDOR O
                 ON O.CDCONSUMIDOR = V.CDCONSUMIDOR
                AND O.NRORG = V.NRORG
              WHERE TRUNC(V.DTHRABERMESA) BETWEEN :DATAINI AND :DATAFIN
                AND C.IDORGCMDVENDA IS NULL
                AND ((INSTR(:CDCONSUMIDOR, V.CDCONSUMIDOR) > 0) OR (:TCDCONSUMIDOR = 'T'))) FILOREST
         ON FILOREST.CDFILIAL = I.CDFILIAL 
        AND FILOREST.NRVENDAREST = I.NRVENDAREST 
        AND FILOREST.NRCOMANDA = I.NRCOMANDA
        AND FILOREST.NRORG = I.NRORG
       JOIN PRODUTO P
         ON I.CDPRODUTO = P.CDPRODUTO
        AND I.NRORG = P.NRORG
      GROUP BY FILOREST.NRVENDAREST, FILOREST.NRCOMANDA, FILOREST.CDLOJA, FILOREST.NMLOJA, FILOREST.CDFILIAL, FILOREST.NMFILIAL, FILOREST.NRORG,
               P.NMPRODUTO, P.CDARVPROD, I.VRPRECCOMVEN, I.QTPRODCOMVEN, FILOREST.NMCONSUMIDOR, FILOREST.DTHRABERMESA
    ";
}